/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package net.kldp.waf;

import java.io.IOException;
import java.io.PrintWriter;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import net.kldp.tomom.agent.*;

/**
 *
 * @author pok
 */
public class AgentCaller extends HttpServlet {
   
	private static RubyAgentEngine rubyAgentEngine = new RubyAgentEngine();
	private String callAgentDebug(String agentFileName) {
		RubyAgentEngine rubyAgentEngineDebug = new RubyAgentEngine();
		RubyAgent agent = rubyAgentEngineDebug.createAgentFromFile(agentFileName);
		if(agent == null)
			return null;

		return agent.run();
	}
    /** 
     * Processes requests for both HTTP <code>GET</code> and <code>POST</code> methods.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        response.setContentType("text/html;charset=UTF-8");
        //response.setContentType("text/html;charset=EUC-KR");
        PrintWriter out = response.getWriter();
        try {
			String agentFile = getServletContext().getRealPath("agent/HelloWaf.rb");
			String result = callAgentDebug(agentFile);
			if(null == result)
				result = agentFile + " is fale to call";

            out.println("<html>");
            out.println("<head>");
            out.println("<title>Servlet AgentCaller</title>");  
            out.println("</head>");
            out.println("<body>");
            out.println("<h1>Servlet AgentCaller at " + request.getContextPath () + "</h1>");
            out.println("<p>" + result + "</p>");
            out.println("</body>");
            out.println("</html>");

        } finally { 
            out.close();
        }
    } 

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /** 
     * Handles the HTTP <code>GET</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        processRequest(request, response);
    } 

    /** 
     * Handles the HTTP <code>POST</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        processRequest(request, response);
    }

    /** 
     * Returns a short description of the servlet.
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>

}
